{$F-}
Program  Pelda08 ;

{     8. Feladat
          kt turbo pascal fprogram ltal hvott assembly
          eljrs:
             az egyik megkeres egy listban egy adott elemet,
             a msik nvekv sorrendbe rendez egy listt a
               kulcsai szerint.
          A paramter-tads verem segtsgvel trtnjen.
}

type
  DataType = boolean ;    {  Ezt az adattipust brmilyen ms
                             tipusra t lehet javtani.      }

  ListaPtr = ^ListaRec ;
  ListaRec = record
               Link  : ListaPtr ;
               Kulcs : integer  ;
               Data  : DataType ;
             end ;

var
  i : integer ;
  L : ListaPtr ;
  P : ListaPtr ;

  function  FindRec  ( L : ListaPtr ; K : integer ) : ListaPtr ;   external ;
  procedure SortList ( L : ListaPtr ; var Result : ListaPtr )  ;   external ;
  {$L Pelda08}


  procedure  Append ( var L : ListaPtr ; K : integer ) ;
  var
    NL : ListaPtr ;
  begin
    new ( NL ) ;
    NL^.Link  := L ;
    NL^.Kulcs := K ;
    NL^.Data  := TRUE ;
    L := NL ;
  end ;

  function  WrtPointer( L : pointer ) : string ;
  var
    x : record  Disp, Segm : word end  absolute L ;

    function  Hex ( W : word ) : string ;
    var
      x : word ;
      i : integer ;
      k : integer ;
      s : string[4] ;
    begin
      x := W ;
      s := '' ;
      for  i := 0  to  3  do
      begin
        k := x and 15 ;
        x := x shr 4  ;
        if  k <= 9  then  s := chr(48+k) +s  else  s := chr(55+k) +s ;
      end ;
      Hex := s
    end ;

  begin   {  Wrt a pointer  }
    WrtPointer := Hex ( x.Segm ) + ':' + Hex ( x.Disp ) ;
  end ;

begin

  writeln ( 'Listakezel program.' ) ;
  writeln ;
  Randomize ;

  L := NIL ;
  for  i := 1  to  100  do
         Append ( L , Random(32767)) ;

  writeln ( 'A teszt lista a kvetkez:' ) ;
  P := L ;
  while  P <> NIL  do
  begin
    write ( '[', P^.Kulcs , '] -> ' ) ;
    P := P^.Link ;
  end ;
  writeln ( 'NIL' ) ;

  writeln ( 'A lista rendezse:') ;
  SortList ( L , P ) ;

  writeln ( 'A rendezett lista a kvetkez:') ;
  L := P ;
  while  L <> NIL  do
  begin
    write ( '[', L^.Kulcs , '] -> ' ) ;
    L := L^.Link ;
  end ;
  writeln ( 'NIL' ) ;

  writeln ( 'Rekord keress:' ) ;
  writeln ( 'A program a -1 kulcs begpelsre megll.' ) ;
  writeln ;

  repeat
    write  ( 'A keresett rekord kulcsa : ' ) ;
    readln ( i ) ;

    if  i <> -1  then
    begin
      L := FindRec ( P , i ) ;

      if  L <> NIL  then
        writeln ( 'A keresett rekord cme : ' , WrtPointer(L) )
      else
        writeln ( 'Nincs ilyen kulccsal rendelkez rekord a listban.' ) ;

    end ;

  until  i = -1 ;

end.
