unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, Psock, NMpop3, Inifiles, ComCtrls;

type
  TForm1 = class(TForm)
    NMPOP31: TNMPOP3;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Panel2: TPanel;
    Label5: TLabel;
    ProgressBar1: TProgressBar;
    ListBox1: TListBox;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    procedure SpeedButton3Click(Sender: TObject);
    procedure NMPOP31Connect(Sender: TObject);
    procedure NMPOP31RetrieveEnd(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure levelle;
    procedure kiir(kiirando: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ini: Tinifile;
  host, user, pass, path: string;
  coun, level: integer;

implementation

uses unit2;

{$R *.dfm}

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  ini := Tinifile.Create(extractfilepath(application.ExeName) + 'adatok.ini'); //Az ini ltrehozsa, az extractfilepath(application.exename) megadja a program knyvtrt.

  if ini.ReadString('Adatok', 'Host', '') = '' then form2.showmodal
  else begin
    host := ini.readstring('Adatok', 'Host', '');
    user := ini.ReadString('Adatok', 'User', '');
    pass := ini.ReadString('Adatok', 'Pass', '');
    path := ini.ReadString('Adatok', 'Path', extractfilepath(application.ExeName));

    if nmpop31.Connected then nmpop31.Disconnect;

    nmpop31.Host := host;
    nmpop31.UserID := user;
    nmpop31.Password := pass;
    nmpop31.AttachFilePath := path;
    panel2.Visible := true;
    speedbutton3.Enabled := false;
    speedbutton4.Enabled := false;
    speedbutton5.Enabled := false;
    speedbutton6.Enabled := false;

    try
      nmpop31.Connect;
    except
      showmessage('Nem lehet a szerverhez kapcsoldni!');
    end;

    ini.Free;
    progressbar1.Max := 1;
  end;

end;

procedure TForm1.NMPOP31Connect(Sender: TObject);
begin
  progressbar1.Position := 1;
  kiir('A Levelek ellenrzse...');
  progressbar1.Position := 0;
  kiir('j rkezett levelek szma: ' + inttostr(nmpop31.MailCount));
  coun := nmpop31.mailcount;
  progressbar1.Position := 1;

  if coun < 1 then begin
    kiir('Nincs j letlthet levl!');
    memo1.Lines.Clear;
    edit1.Text := '';
    edit2.Text := '';
    edit3.Text := '';
    level := 0;
    speedbutton5.Enabled := false;
    speedbutton4.Enabled := false;
    label4.Caption := inttostr(level) + '/' + inttostr(coun);
    progressbar1.Position := 0;
    nmpop31.Disconnect;
  end
  else begin
    kiir('Az ' + inttostr(level) + '. levl letltse...');
    progressbar1.Position := 0;
    progressbar1.Max := 4;
    speedbutton5.Enabled := true;
    speedbutton4.Enabled := true;

    if level = 0 then begin
      level := 1;
      nmpop31.GetMailMessage(1);
    end;

  end;
end;

procedure TForm1.NMPOP31RetrieveEnd(Sender: TObject);
begin
//A letlts befejezse:
  progressbar1.Position := 1;
  edit1.Text := nmpop31.MailMessage.From;
  progressbar1.Position := 2;
  edit2.Text := nmpop31.MailMessage.Subject;
  progressbar1.Position := 3;
  memo1.Lines := nmpop31.MailMessage.Body;
  progressbar1.Position := 4;
  progressbar1.Position := 0;
  progressbar1.Max := 0;
  edit3.Text := datetostr(date);
  label4.Caption := inttostr(level) + '/' + inttostr(coun);

  if level = 1 then speedbutton1.Enabled := false
  else speedbutton1.Enabled := true;

  if level = coun then speedbutton2.Enabled := false
  else speedbutton2.Enabled := true;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  form2.showmodal;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  level := level + 1;
  levelle;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  level := level - 1;
  levelle
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  panel2.Visible := false;
  speedbutton3.Enabled := true;
  speedbutton4.Enabled := true;
  speedbutton5.Enabled := true;
  speedbutton6.Enabled := true;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  if savedialog1.Execute then begin
    memo1.Lines.Insert(0, label1.Caption + edit1.text);
    memo1.Lines.Insert(0, label2.Caption + edit2.text);
    memo1.Lines.Insert(0, label3.Caption + edit3.text);
    memo1.Lines.SaveToFile(savedialog1.FileName);
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  nmpop31.DeleteMailMessage(level);
//A levelek letltsnek vgrehajtse, mert megvltozott a mailcount.
  speedbutton3.Click;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  speedbutton3.Click;
end;

procedure TForm1.levelle;
begin
  kiir('Az ' + inttostr(level) + ' levl letltse...');
  progressbar1.Position := 0;
  progressbar1.Max := 4;

  if nmpop31.Connected = false then nmpop31.Connect;

  try
    nmpop31.GetMailMessage(level);
  finally
    nmpop31.Disconnect;
  end;

end;

procedure TForm1.kiir(kiirando: string);
begin
  listbox1.Items.Add('[' + datetostr(date) + ' ' + timetostr(time) + '] ' + kiirando);
end;

end.

