;
;      8. Feladat:
;         kt turbo pascal fprogram ltal hvott assembly
;         eljrs:
;            az egyik megkeres egy listban egy adott elemet,
;            a msik nvekv sorrendbe rendez egy listt a
;              kulcsai szerint.
;         A paramter-tads verem segtsgvel trtnjen.
;
;
ListaRec        STRUC

Link            DD       ?
Kulcs           DW       ?
Data            DB       ?

ListaRec        ENDS


CODE            segment  para  public  'CODE'
                assume   CS:CODE

                public   FindRec
                public   SortList

;           ...                   A verem tartalma vzlatosan
;          Segm L     bp+8
;          Offs L     bp+6
;          K          bp+4
;              ret    bp+2
;          rgi BP    bp
;                   

FindRec         proc    near                    ; near mert $F- van
                push    bp
                mov     bp,sp

                mov     bx,[bp+4]               ; BX = Kulcs
                les     si,[bp+6]               ; ES:SI = First Rec Addr

Find_Cikl:      mov     ax,es
                or      ax,si
                jz      FindExit

                cmp     es:[si].Kulcs,bx        ; @ES:[SI+Offs Kulcs] ?= BX
                je      FindExit

                les     si,es:[si].Link
                jmp     Find_Cikl

FindExit:       mov     dx,es
                mov     ax,si

                mov     sp,bp
                pop     bp
                ret     6
FindRec         endp

;           ...                   A verem tartalma vzlatosan
;          Segm L     bp+10
;          Offs L     bp+8
;          Segm @Res  bp+6
;          Offs @Res  bp+4
;            ret      bp+2
;          rgi BP    bp
;                       --------------- loklis vltozk
;          Segm @1st  bp-2
;          Offs @1st  bp-4
;          Segm @Nxt  bp-6
;          Offs @Nxt  bp-8
;                   

SortList        proc    near
                push    bp
                mov     bp,sp
                sub     sp,8                    ; helyfoglals

                mov     word ptr [bp-4],0
                mov     word ptr [bp-2],0       ; 1st = NIL

                les     si,[bp+8]
                mov     ax,es
                or      ax,si
                jz      SortExit                ; if L = NIL then exit

                mov     [bp-4],si               ; 1st = els rekord
                mov     [bp-2],es


SortExit:       mov     ax,[bp-4]               ; AX = offset of 1st
                mov     dx,[bp-2]               ; DX = segm of 1st
                les     si,[bp+4]
                mov     es:[si],ax
                mov     es:[si+2],dx

                mov     sp,bp
                pop     bp
                ret     8
SortList        endp


CODE            ends

                end
